diff --git a/app/src/main/java/org/mian/gitnex/adapters/ExploreRepositoriesAdapter.java b/app/src/main/java/org/mian/gitnex/adapters/ExploreRepositoriesAdapter.java
index 88699632..8dc78c31 100644
--- a/app/src/main/java/org/mian/gitnex/adapters/ExploreRepositoriesAdapter.java
+++ b/app/src/main/java/org/mian/gitnex/adapters/ExploreRepositoriesAdapter.java
@@ -19,6 +19,7 @@ import org.mian.gitnex.R;
 import org.mian.gitnex.activities.RepoDetailActivity;
 import org.mian.gitnex.clients.PicassoService;
 import org.mian.gitnex.clients.RetrofitClient;
+import org.mian.gitnex.database.api.BaseApi;
 import org.mian.gitnex.database.api.RepositoriesApi;
 import org.mian.gitnex.database.models.Repository;
 import org.mian.gitnex.helpers.AppUtil;
@@ -98,7 +99,7 @@ public class ExploreRepositoriesAdapter extends RecyclerView.Adapter<ExploreRepo
 				final String repoName = parts[1];
 
 				int currentActiveAccountId = tinyDb.getInt("currentActiveAccountId");
-				RepositoriesApi repositoryData = new RepositoriesApi(context);
+				RepositoriesApi repositoryData = BaseApi.getInstance(context, RepositoriesApi.class);
 
 				//RepositoriesRepository.deleteRepositoriesByAccount(currentActiveAccountId);
 				Integer count = repositoryData.checkRepository(currentActiveAccountId, repoOwner, repoName);
diff --git a/app/src/main/java/org/mian/gitnex/adapters/MyReposListAdapter.java b/app/src/main/java/org/mian/gitnex/adapters/MyReposListAdapter.java
index a0fe9ab2..a7845c8c 100644
--- a/app/src/main/java/org/mian/gitnex/adapters/MyReposListAdapter.java
+++ b/app/src/main/java/org/mian/gitnex/adapters/MyReposListAdapter.java
@@ -21,6 +21,7 @@ import org.mian.gitnex.R;
 import org.mian.gitnex.activities.RepoDetailActivity;
 import org.mian.gitnex.clients.PicassoService;
 import org.mian.gitnex.clients.RetrofitClient;
+import org.mian.gitnex.database.api.BaseApi;
 import org.mian.gitnex.database.api.RepositoriesApi;
 import org.mian.gitnex.database.models.Repository;
 import org.mian.gitnex.helpers.AppUtil;
@@ -96,7 +97,7 @@ public class MyReposListAdapter extends RecyclerView.Adapter<MyReposListAdapter.
 				final String repoName = parts[1];
 
 				int currentActiveAccountId = tinyDb.getInt("currentActiveAccountId");
-				RepositoriesApi repositoryData = new RepositoriesApi(context);
+				RepositoriesApi repositoryData = BaseApi.getInstance(context, RepositoriesApi.class);
 
 				//RepositoriesRepository.deleteRepositoriesByAccount(currentActiveAccountId);
 				Integer count = repositoryData.checkRepository(currentActiveAccountId, repoOwner, repoName);
diff --git a/app/src/main/java/org/mian/gitnex/adapters/NotificationsAdapter.java b/app/src/main/java/org/mian/gitnex/adapters/NotificationsAdapter.java
index a28999e3..7e00d1f9 100644
--- a/app/src/main/java/org/mian/gitnex/adapters/NotificationsAdapter.java
+++ b/app/src/main/java/org/mian/gitnex/adapters/NotificationsAdapter.java
@@ -13,6 +13,7 @@ import androidx.core.text.HtmlCompat;
 import androidx.recyclerview.widget.RecyclerView;
 import org.gitnex.tea4j.models.NotificationThread;
 import org.mian.gitnex.R;
+import org.mian.gitnex.database.api.BaseApi;
 import org.mian.gitnex.database.api.RepositoriesApi;
 import org.mian.gitnex.database.models.Repository;
 import org.mian.gitnex.helpers.TinyDB;
@@ -87,8 +88,7 @@ public class NotificationsAdapter extends RecyclerView.Adapter<NotificationsAdap
 
 		if(notificationThread.isPinned()) {
 			holder.pinned.setVisibility(View.VISIBLE);
-		}
-		else {
+		} else {
 			holder.pinned.setVisibility(View.GONE);
 		}
 
@@ -123,17 +123,14 @@ public class NotificationsAdapter extends RecyclerView.Adapter<NotificationsAdap
 			final String repoName = parts[1];
 
 			int currentActiveAccountId = tinyDb.getInt("currentActiveAccountId");
-			RepositoriesApi repositoryData = new RepositoriesApi(context);
+			RepositoriesApi repositoryData = BaseApi.getInstance(context, RepositoriesApi.class);
 
 			Integer count = repositoryData.checkRepository(currentActiveAccountId, repoOwner, repoName);
 
 			if(count == 0) {
-
 				long id = repositoryData.insertRepository(currentActiveAccountId, repoOwner, repoName);
 				tinyDb.putLong("repositoryId", id);
-			}
-			else {
-
+			} else {
 				Repository data = repositoryData.getRepository(currentActiveAccountId, repoOwner, repoName);
 				tinyDb.putLong("repositoryId", data.getRepositoryId());
 			}
diff --git a/app/src/main/java/org/mian/gitnex/adapters/RepoForksAdapter.java b/app/src/main/java/org/mian/gitnex/adapters/RepoForksAdapter.java
index 700e7289..d432cdad 100644
--- a/app/src/main/java/org/mian/gitnex/adapters/RepoForksAdapter.java
+++ b/app/src/main/java/org/mian/gitnex/adapters/RepoForksAdapter.java
@@ -20,6 +20,7 @@ import org.mian.gitnex.R;
 import org.mian.gitnex.activities.RepoDetailActivity;
 import org.mian.gitnex.clients.PicassoService;
 import org.mian.gitnex.clients.RetrofitClient;
+import org.mian.gitnex.database.api.BaseApi;
 import org.mian.gitnex.database.api.RepositoriesApi;
 import org.mian.gitnex.database.models.Repository;
 import org.mian.gitnex.helpers.AppUtil;
@@ -220,7 +221,7 @@ public class RepoForksAdapter extends RecyclerView.Adapter<RecyclerView.ViewHold
 				final String repoName = parts[1];
 
 				int currentActiveAccountId = tinyDb.getInt("currentActiveAccountId");
-				RepositoriesApi repositoryData = new RepositoriesApi(context);
+				RepositoriesApi repositoryData = BaseApi.getInstance(context, RepositoriesApi.class);
 
 				//RepositoriesRepository.deleteRepositoriesByAccount(currentActiveAccountId);
 				Integer count = repositoryData.checkRepository(currentActiveAccountId, repoOwner, repoName);
diff --git a/app/src/main/java/org/mian/gitnex/adapters/ReposListAdapter.java b/app/src/main/java/org/mian/gitnex/adapters/ReposListAdapter.java
index 360061f9..400dc5b9 100644
--- a/app/src/main/java/org/mian/gitnex/adapters/ReposListAdapter.java
+++ b/app/src/main/java/org/mian/gitnex/adapters/ReposListAdapter.java
@@ -21,6 +21,7 @@ import org.mian.gitnex.R;
 import org.mian.gitnex.activities.RepoDetailActivity;
 import org.mian.gitnex.clients.PicassoService;
 import org.mian.gitnex.clients.RetrofitClient;
+import org.mian.gitnex.database.api.BaseApi;
 import org.mian.gitnex.database.api.RepositoriesApi;
 import org.mian.gitnex.database.models.Repository;
 import org.mian.gitnex.helpers.AppUtil;
@@ -96,7 +97,7 @@ public class ReposListAdapter extends RecyclerView.Adapter<ReposListAdapter.Repo
 				final String repoName = parts[1];
 
 				int currentActiveAccountId = tinyDb.getInt("currentActiveAccountId");
-				RepositoriesApi repositoryData = new RepositoriesApi(context);
+				RepositoriesApi repositoryData = BaseApi.getInstance(context, RepositoriesApi.class);
 
 				//RepositoriesRepository.deleteRepositoriesByAccount(currentActiveAccountId);
 				Integer count = repositoryData.checkRepository(currentActiveAccountId, repoOwner, repoName);
diff --git a/app/src/main/java/org/mian/gitnex/adapters/RepositoriesByOrgAdapter.java b/app/src/main/java/org/mian/gitnex/adapters/RepositoriesByOrgAdapter.java
index fc7d14da..18909561 100644
--- a/app/src/main/java/org/mian/gitnex/adapters/RepositoriesByOrgAdapter.java
+++ b/app/src/main/java/org/mian/gitnex/adapters/RepositoriesByOrgAdapter.java
@@ -21,6 +21,7 @@ import org.mian.gitnex.R;
 import org.mian.gitnex.activities.RepoDetailActivity;
 import org.mian.gitnex.clients.PicassoService;
 import org.mian.gitnex.clients.RetrofitClient;
+import org.mian.gitnex.database.api.BaseApi;
 import org.mian.gitnex.database.api.RepositoriesApi;
 import org.mian.gitnex.database.models.Repository;
 import org.mian.gitnex.helpers.AppUtil;
@@ -96,7 +97,7 @@ public class RepositoriesByOrgAdapter extends RecyclerView.Adapter<RepositoriesB
                 final String repoName = parts[1];
 
                 int currentActiveAccountId = tinyDb.getInt("currentActiveAccountId");
-                RepositoriesApi repositoryData = new RepositoriesApi(context);
+                RepositoriesApi repositoryData = BaseApi.getInstance(context, RepositoriesApi.class);
 
                 //RepositoriesRepository.deleteRepositoriesByAccount(currentActiveAccountId);
                 Integer count = repositoryData.checkRepository(currentActiveAccountId, repoOwner, repoName);
diff --git a/app/src/main/java/org/mian/gitnex/adapters/SearchIssuesAdapter.java b/app/src/main/java/org/mian/gitnex/adapters/SearchIssuesAdapter.java
index dbce44a5..c31dea72 100644
--- a/app/src/main/java/org/mian/gitnex/adapters/SearchIssuesAdapter.java
+++ b/app/src/main/java/org/mian/gitnex/adapters/SearchIssuesAdapter.java
@@ -15,6 +15,7 @@ import org.gitnex.tea4j.models.Issues;
 import org.mian.gitnex.R;
 import org.mian.gitnex.activities.IssueDetailActivity;
 import org.mian.gitnex.clients.PicassoService;
+import org.mian.gitnex.database.api.BaseApi;
 import org.mian.gitnex.database.api.RepositoriesApi;
 import org.mian.gitnex.database.models.Repository;
 import org.mian.gitnex.helpers.AppUtil;
@@ -80,7 +81,7 @@ public class SearchIssuesAdapter extends RecyclerView.Adapter<SearchIssuesAdapte
 				final String repoName = parts[1];
 
 				int currentActiveAccountId = tinyDb.getInt("currentActiveAccountId");
-				RepositoriesApi repositoryData = new RepositoriesApi(context);
+				RepositoriesApi repositoryData = BaseApi.getInstance(context, RepositoriesApi.class);
 
 				Integer count = repositoryData.checkRepository(currentActiveAccountId, repoOwner, repoName);
 
diff --git a/app/src/main/java/org/mian/gitnex/adapters/StarredReposListAdapter.java b/app/src/main/java/org/mian/gitnex/adapters/StarredReposListAdapter.java
index 3ebf5bd8..2151b571 100644
--- a/app/src/main/java/org/mian/gitnex/adapters/StarredReposListAdapter.java
+++ b/app/src/main/java/org/mian/gitnex/adapters/StarredReposListAdapter.java
@@ -21,6 +21,7 @@ import org.mian.gitnex.R;
 import org.mian.gitnex.activities.RepoDetailActivity;
 import org.mian.gitnex.clients.PicassoService;
 import org.mian.gitnex.clients.RetrofitClient;
+import org.mian.gitnex.database.api.BaseApi;
 import org.mian.gitnex.database.api.RepositoriesApi;
 import org.mian.gitnex.database.models.Repository;
 import org.mian.gitnex.helpers.AppUtil;
@@ -96,7 +97,7 @@ public class StarredReposListAdapter extends RecyclerView.Adapter<StarredReposLi
                 final String repoName = parts[1];
 
                 int currentActiveAccountId = tinyDb.getInt("currentActiveAccountId");
-                RepositoriesApi repositoryData = new RepositoriesApi(context);
+                RepositoriesApi repositoryData = BaseApi.getInstance(context, RepositoriesApi.class);
 
                 //RepositoriesRepository.deleteRepositoriesByAccount(currentActiveAccountId);
                 Integer count = repositoryData.checkRepository(currentActiveAccountId, repoOwner, repoName);
diff --git a/app/src/main/java/org/mian/gitnex/adapters/UserAccountsAdapter.java b/app/src/main/java/org/mian/gitnex/adapters/UserAccountsAdapter.java
index d698b997..63371534 100644
--- a/app/src/main/java/org/mian/gitnex/adapters/UserAccountsAdapter.java
+++ b/app/src/main/java/org/mian/gitnex/adapters/UserAccountsAdapter.java
@@ -14,6 +14,7 @@ import androidx.appcompat.content.res.AppCompatResources;
 import androidx.recyclerview.widget.RecyclerView;
 import org.mian.gitnex.R;
 import org.mian.gitnex.clients.PicassoService;
+import org.mian.gitnex.database.api.BaseApi;
 import org.mian.gitnex.database.api.UserAccountsApi;
 import org.mian.gitnex.database.models.UserAccount;
 import org.mian.gitnex.helpers.AppUtil;
@@ -63,7 +64,7 @@ public class UserAccountsAdapter extends RecyclerView.Adapter<UserAccountsAdapte
 					.setPositiveButton(context.getResources().getString(R.string.removeButton), (dialog, which) -> {
 
 						updateLayoutByPosition(getAdapterPosition());
-						UserAccountsApi userAccountsApi = new UserAccountsApi(context);
+						UserAccountsApi userAccountsApi = BaseApi.getInstance(context, UserAccountsApi.class);
 						userAccountsApi.deleteAccount(Integer.parseInt(String.valueOf(accountId)));
 					}).setNeutralButton(context.getResources().getString(R.string.cancelButton), null)
 					.show();
@@ -71,25 +72,19 @@ public class UserAccountsAdapter extends RecyclerView.Adapter<UserAccountsAdapte
 
 			itemView.setOnClickListener(switchAccount -> {
 
-				UserAccountsApi userAccountsApi = new UserAccountsApi(context);
-				UserAccount userAccount = userAccountsApi.getAccountData(accountName);
+				UserAccountsApi userAccountsApi = BaseApi.getInstance(context, UserAccountsApi.class);
+				UserAccount userAccount = userAccountsApi.getAccountByName(accountName);
 
-				if(tinyDB.getInt("currentActiveAccountId") != userAccount.getAccountId()) {
+				if(AppUtil.switchToAccount(context, userAccount)) {
 
 					String url = UrlBuilder.fromString(userAccount.getInstanceUrl())
 						.withPath("/")
 						.toString();
 
-					tinyDB.putString("loginUid", userAccount.getUserName());
-					tinyDB.putString("userLogin", userAccount.getUserName());
-					tinyDB.putString(userAccount.getUserName() + "-token", userAccount.getToken());
-					tinyDB.putString("instanceUrl", userAccount.getInstanceUrl());
-					tinyDB.putInt("currentActiveAccountId", userAccount.getAccountId());
-
 					Toasty.success(context,  context.getResources().getString(R.string.switchAccountSuccess, userAccount.getUserName(), url));
 					((Activity) context).recreate();
-				}
 
+				}
 			});
 
 		}
diff --git a/app/src/main/java/org/mian/gitnex/adapters/UserAccountsNavAdapter.java b/app/src/main/java/org/mian/gitnex/adapters/UserAccountsNavAdapter.java
index 7db88c76..c315ff41 100644
--- a/app/src/main/java/org/mian/gitnex/adapters/UserAccountsNavAdapter.java
+++ b/app/src/main/java/org/mian/gitnex/adapters/UserAccountsNavAdapter.java
@@ -18,12 +18,10 @@ import androidx.drawerlayout.widget.DrawerLayout;
 import androidx.recyclerview.widget.RecyclerView;
 import org.mian.gitnex.R;
 import org.mian.gitnex.clients.PicassoService;
-import org.mian.gitnex.database.api.UserAccountsApi;
 import org.mian.gitnex.database.models.UserAccount;
 import org.mian.gitnex.fragments.UserAccountsFragment;
 import org.mian.gitnex.helpers.AppUtil;
 import org.mian.gitnex.helpers.RoundedTransformation;
-import org.mian.gitnex.helpers.TinyDB;
 import org.mian.gitnex.helpers.Toasty;
 import java.util.List;
 import io.mikael.urlbuilder.UrlBuilder;
@@ -103,7 +101,6 @@ public class UserAccountsNavAdapter extends RecyclerView.Adapter<UserAccountsNav
 
 	private void customDialogUserAccountsList(List<UserAccount> allAccountsList) {
 
-		TinyDB tinyDB = TinyDB.getInstance(context);
 		Dialog dialog = new Dialog(context, R.style.ThemeOverlay_MaterialComponents_Dialog_Alert);
 		dialog.setContentView(R.layout.custom_user_accounts_dialog);
 
@@ -120,6 +117,7 @@ public class UserAccountsNavAdapter extends RecyclerView.Adapter<UserAccountsNav
 			AppCompatActivity activity = (AppCompatActivity) context;
 			activity.getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, new UserAccountsFragment()).commit();
 			dialog.dismiss();
+
 		});
 
 		UserAccountsListDialogAdapter arrayAdapter = new UserAccountsListDialogAdapter(context, R.layout.custom_user_accounts_list, allAccountsList);
@@ -127,27 +125,21 @@ public class UserAccountsNavAdapter extends RecyclerView.Adapter<UserAccountsNav
 
 		listView.setOnItemClickListener((adapterView, view, which, l) -> {
 
-			String accountNameSwitch = allAccountsList.get(which).getAccountName();
-			UserAccountsApi userAccountsApi = new UserAccountsApi(context);
-			UserAccount userAccount = userAccountsApi.getAccountData(accountNameSwitch);
+			UserAccount userAccount = allAccountsList.get(which);
 
-			if(tinyDB.getInt("currentActiveAccountId") != userAccount.getAccountId()) {
+			if(AppUtil.switchToAccount(context, userAccount)) {
 
 				String url = UrlBuilder.fromString(userAccount.getInstanceUrl())
 					.withPath("/")
 					.toString();
 
-				tinyDB.putString("loginUid", userAccount.getUserName());
-				tinyDB.putString("userLogin", userAccount.getUserName());
-				tinyDB.putString(userAccount.getUserName() + "-token", userAccount.getToken());
-				tinyDB.putString("instanceUrl", userAccount.getInstanceUrl());
-				tinyDB.putInt("currentActiveAccountId", userAccount.getAccountId());
-
 				Toasty.success(context,  context.getResources().getString(R.string.switchAccountSuccess, userAccount.getUserName(), url));
 				((Activity) context).recreate();
 				dialog.dismiss();
+
 			}
 		});
+
 		dialog.show();
 	}
 
diff --git a/app/src/main/java/org/mian/gitnex/core/MainApplication.java b/app/src/main/java/org/mian/gitnex/core/MainApplication.java
index 5fd91d2c..cb921174 100644
--- a/app/src/main/java/org/mian/gitnex/core/MainApplication.java
+++ b/app/src/main/java/org/mian/gitnex/core/MainApplication.java
@@ -3,6 +3,7 @@ package org.mian.gitnex.core;
 import android.annotation.SuppressLint;
 import android.app.Application;
 import android.content.Context;
+import androidx.core.content.res.ResourcesCompat;
 import org.acra.ACRA;
 import org.acra.BuildConfig;
 import org.acra.ReportField;
@@ -34,7 +35,6 @@ import org.mian.gitnex.notifications.Notifications;
 
 public class MainApplication extends Application {
 
-	private Context appCtx;
 	private TinyDB tinyDB;
 
 	@Override
@@ -42,7 +42,7 @@ public class MainApplication extends Application {
 
 		super.onCreate();
 
-		appCtx = getApplicationContext();
+		Context appCtx = getApplicationContext();
 		tinyDB = TinyDB.getInstance(appCtx);
 
 		setDefaults();
@@ -76,6 +76,7 @@ public class MainApplication extends Application {
 
 	@Override
 	protected void attachBaseContext(Context context) {
+
 		super.attachBaseContext(context);
 
 		tinyDB = TinyDB.getInstance(context);
@@ -97,46 +98,59 @@ public class MainApplication extends Application {
 
 		// enabling counter badges by default
 		if(tinyDB.getString("enableCounterBadgesInit").isEmpty()) {
-
 			tinyDB.putBoolean("enableCounterBadges", true);
 			tinyDB.putString("enableCounterBadgesInit", "yes");
 		}
 
 		// enable crash reports by default
 		if(tinyDB.getString("crashReportingEnabledInit").isEmpty()) {
-
 			tinyDB.putBoolean("crashReportingEnabled", true);
 			tinyDB.putString("crashReportingEnabledInit", "yes");
 		}
 
 		// default cache setter
 		if(tinyDB.getString("cacheSizeStr").isEmpty()) {
-
 			tinyDB.putString("cacheSizeStr", getResources().getString(R.string.cacheSizeDataSelectionSelectedText));
 		}
 		if(tinyDB.getString("cacheSizeImagesStr").isEmpty()) {
-
 			tinyDB.putString("cacheSizeImagesStr", getResources().getString(R.string.cacheSizeImagesSelectionSelectedText));
 		}
 
 		// enable comment drafts by default
 		if(tinyDB.getString("draftsCommentsDeletionEnabledInit").isEmpty()) {
-
 			tinyDB.putBoolean("draftsCommentsDeletionEnabled", true);
 			tinyDB.putString("draftsCommentsDeletionEnabledInit", "yes");
 		}
 
 		// setting default polling delay
 		if(tinyDB.getInt("pollingDelayMinutes", 0) <= 0) {
-
 			tinyDB.putInt("pollingDelayMinutes", Constants.defaultPollingDelay);
 		}
 
 		// disable biometric by default
 		if(tinyDB.getString("biometricStatusInit").isEmpty()) {
-
 			tinyDB.putBoolean("biometricStatus", false);
 			tinyDB.putString("biometricStatusInit", "yes");
 		}
+
+		// set default date format
+		if(tinyDB.getString("dateFormat").isEmpty()) {
+			tinyDB.putString("dateFormat", "pretty");
+		}
+
+		if(tinyDB.getString("codeBlockStr").isEmpty()) {
+			tinyDB.putInt("codeBlockColor", ResourcesCompat.getColor(getResources(), R.color.colorLightGreen, null));
+			tinyDB.putInt("codeBlockBackground", ResourcesCompat.getColor(getResources(), R.color.black, null));
+		}
+
+		if(tinyDB.getString("enableCounterIssueBadgeInit").isEmpty()) {
+			tinyDB.putBoolean("enableCounterIssueBadge", true);
+		}
+
+		if(tinyDB.getString("homeScreenStr").isEmpty()) {
+			tinyDB.putString("homeScreenStr", "yes");
+			tinyDB.putInt("homeScreenId", 0);
+		}
+
 	}
 }
diff --git a/app/src/main/java/org/mian/gitnex/database/api/BaseApi.java b/app/src/main/java/org/mian/gitnex/database/api/BaseApi.java
new file mode 100644
index 00000000..ac5beaa8
--- /dev/null
+++ b/app/src/main/java/org/mian/gitnex/database/api/BaseApi.java
@@ -0,0 +1,57 @@
+package org.mian.gitnex.database.api;
+
+import android.content.Context;
+import androidx.annotation.NonNull;
+import org.mian.gitnex.database.db.GitnexDatabase;
+import org.mian.gitnex.helpers.Constants;
+import java.lang.reflect.InvocationTargetException;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+import java.util.Optional;
+import java.util.concurrent.ExecutorService;
+import java.util.concurrent.Executors;
+
+/**
+ * @author opyale
+ */
+
+public abstract class BaseApi {
+
+	private static final Map<Class<? extends BaseApi>, Object> instances = new HashMap<>();
+
+	protected static final ExecutorService executorService = Executors.newCachedThreadPool();
+	protected final GitnexDatabase gitnexDatabase;
+
+	protected BaseApi(Context context) {
+		gitnexDatabase = GitnexDatabase.getDatabaseInstance(context);
+	}
+
+	public static <T extends BaseApi> T getInstance(@NonNull Context context, @NonNull Class<T> clazz) {
+
+		try {
+
+			if(!instances.containsKey(clazz)) {
+				synchronized(BaseApi.class) {
+					if(!instances.containsKey(clazz)) {
+
+						T instance = clazz
+							.getDeclaredConstructor(Context.class)
+							.newInstance(context);
+
+						instances.put(clazz, instance);
+						return instance;
+					}
+				}
+			}
+
+			return (T) instances.get(clazz);
+
+		} catch(NoSuchMethodException | IllegalAccessException |
+			InvocationTargetException | InstantiationException ignored) {}
+
+		return null;
+	}
+
+}
diff --git a/app/src/main/java/org/mian/gitnex/database/api/DraftsApi.java b/app/src/main/java/org/mian/gitnex/database/api/DraftsApi.java
index 8a4307f0..24b8b688 100644
--- a/app/src/main/java/org/mian/gitnex/database/api/DraftsApi.java
+++ b/app/src/main/java/org/mian/gitnex/database/api/DraftsApi.java
@@ -1,30 +1,23 @@
 package org.mian.gitnex.database.api;
 
 import android.content.Context;
-import android.util.Log;
 import androidx.lifecycle.LiveData;
 import org.mian.gitnex.database.dao.DraftsDao;
-import org.mian.gitnex.database.db.GitnexDatabase;
 import org.mian.gitnex.database.models.Draft;
 import org.mian.gitnex.database.models.DraftWithRepository;
-import org.mian.gitnex.helpers.Constants;
 import java.util.List;
 
 /**
  * Author M M Arif
  */
 
-public class DraftsApi {
+public class DraftsApi extends BaseApi {
 
-	private static DraftsDao draftsDao;
-	private static long draftId;
-	private static Integer checkDraftFlag;
+	private final DraftsDao draftsDao;
 
-	public DraftsApi(Context context) {
-
-		GitnexDatabase db;
-		db = GitnexDatabase.getDatabaseInstance(context);
-		draftsDao = db.draftsDao();
+	DraftsApi(Context context) {
+		super(context);
+		draftsDao = gitnexDatabase.draftsDao();
 	}
 
 	public long insertDraft(int repositoryId, int draftAccountId, int issueId, String draftText, String draftType, String commentId, String issueType) {
@@ -41,87 +34,44 @@ public class DraftsApi {
 		return insertDraftAsyncTask(draft);
 	}
 
-	private static long insertDraftAsyncTask(final Draft draft) {
-
-		try {
-
-			Thread thread = new Thread(() -> draftId = draftsDao.insertDraft(draft));
-			thread.start();
-			thread.join();
-		}
-		catch(InterruptedException e) {
-
-			Log.e(Constants.draftsApi, e.toString());
-		}
-
-		return draftId;
+	private long insertDraftAsyncTask(final Draft draft) {
+		return draftsDao.insertDraft(draft);
 	}
 
 	public long getDraftIdAsync(int issueId, int draftRepositoryId) {
-
-		try {
-
-			Thread thread = new Thread(() -> draftId = draftsDao.getDraftId(issueId, draftRepositoryId));
-			thread.start();
-			thread.join();
-		}
-		catch(InterruptedException e) {
-
-			Log.e(Constants.draftsApi, e.toString());
-		}
-
-		return draftId;
+		return draftsDao.getDraftId(issueId, draftRepositoryId);
 	}
 
 	public Integer checkDraft(int issueId, int draftRepositoryId, String commentId) {
-
-		try {
-
-			Thread thread = new Thread(() -> checkDraftFlag = draftsDao.checkDraftDao(issueId, draftRepositoryId, commentId));
-			thread.start();
-			thread.join();
-		}
-		catch(InterruptedException e) {
-
-			Log.e(Constants.draftsApi, e.toString());
-		}
-
-		return checkDraftFlag;
+		return draftsDao.checkDraftDao(issueId, draftRepositoryId, commentId);
 	}
 
 	public LiveData<List<DraftWithRepository>> getDrafts(int accountId) {
-
 		return draftsDao.fetchAllDrafts(accountId);
 	}
 
 	public LiveData<Draft> getDraftByIssueId(int issueId) {
-
 		return draftsDao.fetchDraftByIssueId(issueId);
 	}
 
 	public void deleteSingleDraft(final int draftId) {
-
 		final LiveData<Draft> draft = draftsDao.fetchDraftById(draftId);
 
 		if(draft != null) {
-
-			new Thread(() -> draftsDao.deleteByDraftId(draftId)).start();
+			executorService.execute(() -> draftsDao.deleteByDraftId(draftId));
 		}
 	}
 
-	public static void deleteAllDrafts(final int accountId) {
-
-		new Thread(() -> draftsDao.deleteAllDrafts(accountId)).start();
+	public void deleteAllDrafts(final int accountId) {
+		executorService.execute(() -> draftsDao.deleteAllDrafts(accountId));
 	}
 
-	public static void updateDraft(final String draftText, final int draftId, final String commentId) {
-
-		new Thread(() -> draftsDao.updateDraft(draftText, draftId, commentId)).start();
+	public void updateDraft(final String draftText, final int draftId, final String commentId) {
+		executorService.execute(() -> draftsDao.updateDraft(draftText, draftId, commentId));
 	}
 
-	public static void updateDraftByIssueIdAsyncTask(final String draftText, final int issueId, final int draftRepositoryId, final String commentId) {
-
-		new Thread(() -> draftsDao.updateDraftByIssueId(draftText, issueId, draftRepositoryId, commentId)).start();
+	public void updateDraftByIssueIdAsyncTask(final String draftText, final int issueId, final int draftRepositoryId, final String commentId) {
+		executorService.execute(() -> draftsDao.updateDraftByIssueId(draftText, issueId, draftRepositoryId, commentId));
 	}
 
 }
diff --git a/app/src/main/java/org/mian/gitnex/database/api/RepositoriesApi.java b/app/src/main/java/org/mian/gitnex/database/api/RepositoriesApi.java
index ef5e1f5d..effc415d 100644
--- a/app/src/main/java/org/mian/gitnex/database/api/RepositoriesApi.java
+++ b/app/src/main/java/org/mian/gitnex/database/api/RepositoriesApi.java
@@ -1,30 +1,22 @@
 package org.mian.gitnex.database.api;
 
 import android.content.Context;
-import android.util.Log;
 import androidx.lifecycle.LiveData;
 import org.mian.gitnex.database.dao.RepositoriesDao;
-import org.mian.gitnex.database.db.GitnexDatabase;
 import org.mian.gitnex.database.models.Repository;
-import org.mian.gitnex.helpers.Constants;
 import java.util.List;
 
 /**
  * Author M M Arif
  */
 
-public class RepositoriesApi {
+public class RepositoriesApi extends BaseApi {
 
-	private static RepositoriesDao repositoriesDao;
-	private static long repositoryId;
-	private static Repository repository;
-	private static Integer checkRepository;
+	private final RepositoriesDao repositoriesDao;
 
-	public RepositoriesApi(Context context) {
-
-		GitnexDatabase db;
-		db = GitnexDatabase.getDatabaseInstance(context);
-		repositoriesDao = db.repositoriesDao();
+	RepositoriesApi(Context context) {
+		super(context);
+		repositoriesDao = gitnexDatabase.repositoriesDao();
 	}
 
 	public long insertRepository(int repoAccountId, String repositoryOwner, String repositoryName) {
@@ -38,108 +30,43 @@ public class RepositoriesApi {
 	}
 
 	public long insertRepositoryAsyncTask(Repository repository) {
-
-		try {
-
-			Thread thread = new Thread(() -> repositoryId = repositoriesDao.newRepository(repository));
-			thread.start();
-			thread.join();
-		}
-		catch(InterruptedException e) {
-
-			Log.e(Constants.repositoriesApi, e.toString());
-		}
-
-		return repositoryId;
+		return repositoriesDao.newRepository(repository);
 	}
 
 	public Repository getRepository(int repoAccountId, String repositoryOwner, String repositoryName) {
-
-		try {
-
-			Thread thread = new Thread(() -> repository = repositoriesDao.getSingleRepositoryDao(repoAccountId, repositoryOwner, repositoryName));
-			thread.start();
-			thread.join();
-		}
-		catch(InterruptedException e) {
-
-			Log.e(Constants.repositoriesApi, e.toString());
-		}
-
-		return repository;
+		return repositoriesDao.getSingleRepositoryDao(repoAccountId, repositoryOwner, repositoryName);
 	}
 
 	public LiveData<List<Repository>> getAllRepositories() {
-
 		return repositoriesDao.fetchAllRepositories();
 	}
 
 	public LiveData<List<Repository>> getAllRepositoriesByAccount(int repoAccountId) {
-
 		return repositoriesDao.getAllRepositoriesByAccountDao(repoAccountId);
 	}
 
 	public Integer checkRepository(int repoAccountId, String repositoryOwner, String repositoryName) {
-
-		try {
-
-			Thread thread = new Thread(() -> checkRepository = repositoriesDao.checkRepositoryDao(repoAccountId, repositoryOwner, repositoryName));
-			thread.start();
-			thread.join();
-		}
-		catch(InterruptedException e) {
-
-			Log.e(Constants.repositoriesApi, e.toString());
-		}
-
-		return checkRepository;
+		return repositoriesDao.checkRepositoryDao(repoAccountId, repositoryOwner, repositoryName);
 	}
 
 	public Repository fetchRepositoryById(int repositoryId) {
-
-		try {
-
-			Thread thread = new Thread(() -> repository = repositoriesDao.fetchRepositoryByIdDao(repositoryId));
-			thread.start();
-			thread.join();
-		}
-		catch(InterruptedException e) {
-
-			Log.e(Constants.repositoriesApi, e.toString());
-		}
-
-		return repository;
+		return repositoriesDao.fetchRepositoryByIdDao(repositoryId);
 	}
 
 	public Repository fetchRepositoryByAccountIdByRepositoryId(int repositoryId, int repoAccountId) {
-
-		try {
-
-			Thread thread = new Thread(() -> repository = repositoriesDao.fetchRepositoryByAccountIdByRepositoryIdDao(repositoryId, repoAccountId));
-			thread.start();
-			thread.join();
-		}
-		catch(InterruptedException e) {
-
-			Log.e(Constants.repositoriesApi, e.toString());
-		}
-
-		return repository;
+		return repositoriesDao.fetchRepositoryByAccountIdByRepositoryIdDao(repositoryId, repoAccountId);
 	}
 
-	public static void updateRepositoryOwnerAndName(String repositoryOwner, String repositoryName, int repositoryId) {
-
-		new Thread(() -> repositoriesDao.updateRepositoryOwnerAndName(repositoryOwner, repositoryName, repositoryId)).start();
+	public void updateRepositoryOwnerAndName(String repositoryOwner, String repositoryName, int repositoryId) {
+		executorService.execute(() -> repositoriesDao.updateRepositoryOwnerAndName(repositoryOwner, repositoryName, repositoryId));
 	}
 
-	public static void deleteRepositoriesByAccount(final int repoAccountId) {
-
-		new Thread(() -> repositoriesDao.deleteRepositoriesByAccount(repoAccountId)).start();
+	public void deleteRepositoriesByAccount(final int repoAccountId) {
+		executorService.execute(() -> repositoriesDao.deleteRepositoriesByAccount(repoAccountId));
 	}
 
-	public static void deleteRepository(final int repositoryId) {
-
-		new Thread(() -> repositoriesDao.deleteRepository(repositoryId)).start();
+	public void deleteRepository(final int repositoryId) {
+		executorService.execute(() -> repositoriesDao.deleteRepository(repositoryId));
 	}
 
 }
